extern int PasswordDialog (HWND hDlg, int Msg, int wParam, int lParam)
{
	static HWND SystemMenu ;
	for(;;)
	{
		if(Msg==WM_INITDIALOG)
		{
			PasswordDialog_hWnd=hDlg;
			SendMessage(PasswordDialog_hWnd, WM_SETICON, TRUE,(LPARAM)LoadIcon(GetWindowInstance(PasswordDialog_hWnd), MAKEINTRESOURCE(100)));
			SendMessage(PasswordDialog_hWnd,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)TitleCaption);

			SystemMenu = GetSystemMenu(PasswordDialog_hWnd,FALSE);
			AppendMenu(SystemMenu,MF_SEPARATOR,0,0);
			AppendMenu(SystemMenu,MF_STRING,VersionInfo,"Version");

			CenterWindow(PasswordDialog_hWnd);
			InfoTextStatic_hWnd=GetDlgItem(PasswordDialog_hWnd,101);
			PasswordEdit_hWnd=GetDlgItem(PasswordDialog_hWnd,102);
			if(encr || !decr)
				SetText(InfoTextStatic_hWnd,"Enter A Password To Be Used To Encrypt This Data");
			if(decr || !encr)
				SetText(InfoTextStatic_hWnd,"Enter The Password That Was Used To Encrypt This Data.");
			break;
		}
		//----------------------------------------------------------------------

		if(Msg==WM_COMMAND)
		{
			if(wParam==103)
			{
				if(encr || !decr) //Encrypt
				{
					EndDialog(PasswordDialog_hWnd,0);
					CleanUp(0,1);

					if(Encrypted(F))
					{
						MessageBox (0, "The File You Are Trying To Encrypt Is Already Encrypted!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
						CleanUp(0,1);
						break;
					}

					CleanUp(0,1);

					if(incode(F,GetText(PasswordEdit_hWnd)) == 0);
					{
						CleanUp(0,0);

						if(IncodeMain(EncryptTemp,F) == 0)
						{
							MessageBox (0, "The File Was Successfully Encrypted." , TitleCaption, 0 + MB_ICONASTERISK);
							CleanUp(0,1);
						}
						else
							{
								CleanUp(1,1);
							}
					}
				}

				if(decr || !encr) //Decrypt
				{
					EndDialog(PasswordDialog_hWnd,0);
					CleanUp(0,1);

					if(!Encrypted(F))
					{
						MessageBox (0, "The File You Are Trying To Decrypt Is Not Encrypted!" , TitleCaption, 0 + MB_ICONASTERISK);
						CleanUp(0,1);
						break;
					}

					RemoveFlag(F);
					CleanUp(0,1);

					if(DecodeMain(FileToChangeTemp,EncryptTemp) == 0)
					{
						CleanUp(0,0);
						if(decode(F,GetText(PasswordEdit_hWnd)) == 128)
							MessageBox (0, "The File Was Successfully Decrypted." , TitleCaption, 0 + MB_ICONASTERISK);
						CleanUp(0,1);
					}
					else
					   {
							CleanUp(1,1);
					   }

					unlink(FileToChangeTemp);
				}
				CleanUp(0,1);
				encr = 0;
				decr = 0;
				EndDialog(PasswordDialog_hWnd,0);
			}

			if(wParam==104) //Close Dialog
			{
				CleanUp(0,1);
				encr = 0;
				decr = 0;
				EndDialog(PasswordDialog_hWnd,0);
			}
			if(wParam==106) //Open About Dialog
			{
				DialogBox(hInstance,MAKEINTRESOURCE(300),PasswordDialog_hWnd,AboutDialog);
			}
			break;
		}

		if(Msg==WM_SYSCOMMAND)
		{
			if(LOWORD(wParam) == VersionInfo)
			{
				MessageBox(PasswordDialog_hWnd,Version ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
			}
		}

		if(Msg==WM_CLOSE) //Close Dialog
		{
			CleanUp(0,1);
			encr = 0;
			decr = 0;
			EndDialog(PasswordDialog_hWnd,0);
		}
		break;
	}
	return 0;
}

