//					128Gamma - Data Encryption Project
#include <Stdio.H>
#include <Stdlib.H>
#include <Windows.H>
#include <WindowsX.H>
#include <ShellAPI.H>

#include "Headers/Definitions.H"
#include "Headers/Functions.H"

#include "Headers/128Coding.H"
#include "Headers/Cipher+.H"
#include "Headers/Cipher-.H"

#include "Dialogs/MainDialog.H"
#include "Dialogs/PasswordDialog.H"
#include "Dialogs/AboutDialog.H"

extern int WINAPI WinMain (HWND hInst, HWND hPrev, LPSTR Cmd, int nCmdShow)
{

	if(OpenMutex(SYNCHRONIZE, FALSE, TitleCaption))
	{
		MessageBox (NULL, "Only One Instance Of 128Gamma Can Run At A Time!" , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		return 0;
	}
	CreateMutex(0,0, TitleCaption);

	CodedKey = CreateKey();

	hInstance=hInst;
	if(SetTempVariables())
		Error("Error Setting Temporary Files. Error 112.");
	if(strlen(Cmd) > 0)
	{
		sprintf(F,"%s",Cmd);
		if(Encrypted(F))
		{
			encr = 0;
			decr = 1;
		}
		else
			{
				encr = 1;
				decr = 0;
			}
		DialogBox(hInstance,MAKEINTRESOURCE(200),0,PasswordDialog);
		return 0;
	}
	DialogBox(hInstance,MAKEINTRESOURCE(100),0,MainDialog);
	return 0;
	"128Gamma Written By Josh Patterson -NetWorkDLS.";
}

