//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Working_File)fclose(Working_File);
	if(CypherTemp_File)fclose(CypherTemp_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);
	Header[0] = '\0';
	Temp[0] = '\0';
	Key[0] = '\0';
	Char_Buffer = '\0';
	KeyLeinght = 0;
	LoopCount = 0;
	End_Of_File = 0;
	if(Delete)
	{
		unlink(EncryptTemp);
		unlink(CypherTemp);
	}
	if(Kill)
	{
		unlink(EncryptTemp);
		unlink(CypherTemp);
		unlink(FileToChangeTemp);
		LoopCount = 0;
		KeyLeinght = 0;
		End_Of_File = 0;
		CypherTemp[0] = '\0';
		EncryptTemp[0] = '\0';
		FileToChangeTemp[0] = '\0';
		F[0] = '\0';
		Header[0] = '\0';
		Temp[0] = '\0';
		Key[0] = '\0';
		Char_Buffer = '\0';
		exit(0);
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	FILE * FileToCheck_File;
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 109.");

	while (End_Of_File != EOF)
	{
		End_Of_File = fscanf(FileToCheck_File, "%c", &Char_Buffer);
		LoopCount++;
		if(LoopCount < 11)
			sprintf(Header,"%s%s",Header,&Char_Buffer);
		if(LoopCount == 11)
		{
			if(strcmp(Header,"Encrypted~") != 0)
			{
				if(FileToCheck_File)
					fclose(FileToCheck_File);
				End_Of_File = 0;
				return 0;
			}
			else
				{
				if(FileToCheck_File)
					fclose(FileToCheck_File);
				End_Of_File = 0;
				return 1;
			}
		}
	}
	if(FileToCheck_File)
		fclose(FileToCheck_File);
	End_Of_File = 0;
	return 0;
}

//////////////////////////////////////////////////////////////////////

void RemoveFlag(char *FileToChange)
{
	LoopCount = 0;
	FILE *FileToChange_File , *FileToChangeTemp_File;
	if((FileToChange_File = fopen(FileToChange,"rb")) == NULL)
		Error("Could Not Open Source For Read.	Error: 110.");
	if((FileToChangeTemp_File = fopen(FileToChangeTemp,"wb")) == NULL)
		Error("Could Not Open Source For Read. Error: 111.");
	while (End_Of_File != EOF)
	{
		End_Of_File = fscanf(FileToChange_File, "%c", &Char_Buffer);
		LoopCount++;
		if(LoopCount > 10 && End_Of_File != EOF)
		{
			fprintf(FileToChangeTemp_File, "%c", Char_Buffer);
		}
	}
	if(FileToChangeTemp_File)
		fclose(FileToChangeTemp_File);
	if(FileToChange_File)
		fclose(FileToChange_File);
	End_Of_File = 0;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables()
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"EncryptTemp.128");
	sprintf(CypherTemp,"%s\\%s",GetTempDirectory(),"CypherTemp.128");
	sprintf(FileToChangeTemp,"%s\\%s",GetTempDirectory(),"FileChangeTemp.128");
	if(!EncryptTemp)
		return 1;
	if(!CypherTemp)
		return 1;
	if(!FileToChangeTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int OpenFileDialog (HWND hWnd, char *zCaption, char *zFilespec, char *zInitialDir, char *zFilter, char *zDefExtension, int Flags)
{
	static	OPENFILENAME  ofn;
	static char File[2048];
	static char FileTitle[2048];
	static char Filter[2048];
	static char InitialDir[2048];
	static char Title[100];
	static char DefExt[2048];
	static int RetFlg;
	if(strlen(zInitialDir)==0)
	{
		sprintf(InitialDir,"%s",CurDir());
	}
	sprintf(Filter,"%s",zFilter);
	sprintf(InitialDir,"%s",zInitialDir);
	sprintf(File,"%s",zFilespec);
	sprintf(DefExt,"%s",zDefExtension);
	sprintf(Title,"%s",zCaption);
	ofn.lStructSize=sizeof(ofn);
	ofn.hwndOwner=hWnd;
	ofn.lpstrFilter=Filter;
	ofn.nFilterIndex=1;
	ofn.lpstrFile=File;
	ofn.nMaxFile=sizeof(File);
	ofn.lpstrFileTitle=FileTitle;
	ofn.nMaxFileTitle=sizeof(FileTitle);
	ofn.lpstrInitialDir=InitialDir;
	ofn.Flags=Flags;
	ofn.lpstrDefExt=DefExt;
	ofn.Flags = 527372;
	if(strlen(Title)>0)
	{
		ofn.lpstrTitle=Title;
	}
	RetFlg=GetOpenFileName(&ofn);
	sprintf(zFilespec,"%s",File);
	Flags=ofn.Flags;
	return RetFlg;
}

//////////////////////////////////////////////////////////////////////

extern char *CurDir (void)
{
	static int StrCnt;
	LPSTR StrFunc [16];
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	GetCurrentDirectory (1024,StrFunc[StrCnt]);
	return StrFunc[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern int CharInt(char *string2convert)
{
	int i, lenght_string;
	int power;
	int tmp_number;
	char tmp_char;
	if (!string2convert)
	{
		string2convert = "0";
		Error("Character To Interger Conversion Error. Error: 108.");
		return -1;
	}
	lenght_string = strlen(string2convert);
	for(i = 0; i < (lenght_string / 2); i++)
	{
		tmp_char = string2convert[i];
		string2convert[i] = string2convert[lenght_string - 1 - i];
		string2convert[lenght_string - 1 - i] = tmp_char;
	}
	power = 1;
	i = 0;
	tmp_number = 0;
	while (string2convert[i] != '\0')
	{
		tmp_number += (string2convert[i] - '0') * power;
		power *= 10;
		i++;
	}
	return tmp_number;
}

/////////////////////////////////////////////////////////////////////

extern char *StringScan (char *S, int length1, int length2)
{
	static	char StrFunction [64][257];
	static int StrCnt;
	if(++StrCnt==64) StrCnt = 0;
	strncpy (StrFunction[StrCnt], &S[length1], length2);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char T [257];
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	LPSTR StrFunc [16];
	static int	 StrCnt;
	static int T;
	static char Buffer[2048];
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,Buffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",Buffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static	RECT  wRect;
	static	DWORD  x;
	static	DWORD  y;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern char *CreateKey(void)
{
	static char xCodedKey[27];
	sprintf(xCodedKey,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",49,50,56,71,97,109,109,97,126,69,110,99,114,121,112,116,101,100);
	return xCodedKey;
}

/////////////////////////////////////////////////////////////////////

